// CS 240
// Jace Miller
// main.cpp

#include <stdlib.h>
#include <time.h>
#include <math.h>
#include "glut.h"
#include "particle.h"

const int POINT_COUNT = 2000;
const int LINE_COUNT = 2000;
const int CONFETTI_COUNT = POINT_COUNT + LINE_COUNT;
int g_windowWidth = 800;
int g_windowHeight = 600;
static float g_degrees = 0.0;

// points to Drawable objects which will be filled with drawable Points and Lines
Drawable * g_confetti[CONFETTI_COUNT];
Point g_Points[POINT_COUNT];
Line g_Lines[LINE_COUNT];

void buildPointList()
{
	for(int i = 0; i < POINT_COUNT; ++i)
	{
		g_Lines[i].respawn();
		// build the list of drawable pointers
		g_confetti[i] = g_Points[i].getDrawable();
	}
}

void buildLineList()
{
	for(int i = 0; i < LINE_COUNT; ++i)
	{
		g_Points[i].respawn();
		// build the list of drawable pointers
		g_confetti[POINT_COUNT + i] = g_Lines[i].getDrawable();
	}
}

void display()
{
	int i = 0;

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();

	// spin the camera
	g_degrees += 0.01;
	if(g_degrees > 6.283185)
	{
		g_degrees = 0.0;
	}
	gluLookAt(80.0 * cos(g_degrees), 45.0 + 25.0 * sin(g_degrees), 80.0 * sin(g_degrees), 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);

	// draw a green square for ground
	glColor3f(0.0, 0.6, 0.0);
	glBegin(GL_QUADS);
		glVertex3f(-50.0, 0.0, -50.0);
		glVertex3f(50.0, 0.0, -50.0);
		glVertex3f(50.0, 0.0, 50.0);
		glVertex3f(-50.0, 0.0, 50.0);
	glEnd();

	for(i = 0; i < CONFETTI_COUNT; ++i)
	{
		// This is where the power of interfaces shows itself.
		// Only Drawable functions are called, and they refer to the 
		// proper implementing classes, whether point or line.
		g_confetti[i]->draw();
		g_confetti[i]->update();
	}

	// time wasting loop
	for(i = 0; i < 10000000; ++i);

	glutSwapBuffers();
	glutPostRedisplay();
}

void reshape(int width, int height)
{
	g_windowWidth = width;
	g_windowHeight = height;
	
	glViewport(0, 0, g_windowWidth, g_windowHeight);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(45.0, float(g_windowWidth)/float(g_windowHeight), 0.1, 200.0);
	glMatrixMode(GL_MODELVIEW);
}

int main(int argc, char** argv)
{
	glutInit(&argc, argv);
	glutInitWindowSize(g_windowWidth, g_windowHeight);
	glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH);
	glutCreateWindow("Confetti");
	
	srand(time(NULL));

	glutDisplayFunc(display);
	glutReshapeFunc(reshape);

	buildPointList();
	buildLineList();
	
	glutMainLoop();
	
	return 0;
}
