// CS 240
// Jace Miller
// particle.cpp

#include "glut.h"
#include "particle.h"

/******************************************************************************/

// returns a random number in the range from min to max

float random(float min, float max)
{
	return (((float)(rand() % 10000) / 10000.0 * (max - min)) + min);
}

/******************************************************************************/

// resets the particle to the origin, and randomly generates a new velocity and color

void Particle::respawn()
{
	float red = 0.0;
	float green = 0.0;

	// create spark colors (red, orange, yellow)
	while((red + green < 1.0) || (red + green) > 1.6)
	{
		red = random(0.7, 1.0);
		green = random(0.0, 1.0);
	}
	setColor(red, green, 0.0);

	setPosition(0.0, 0.0, 0.0);
	setVelocity(random(-1.0, 1.0), random(0.0, 2.5), random(-1.0, 1.0));
	setAcceleration(0.0, -0.1, 0.0);
}

/******************************************************************************/

// simulates gravity and respawns particles that have fallen too far

void Particle::update()
{
	mVelocity.add(mAcceleration);
	mPosition.add(mVelocity);
	if(mPosition.getY() < 0)
	{
		respawn();
	}
}

/******************************************************************************/

// a Point is drawn as a single pixel at its current position

void Point::draw()
{
	glBegin(GL_POINTS);
		glColor3f(mColor.getX(), mColor.getY(), mColor.getZ());
		glVertex3f(mPosition.getX(), mPosition.getY(), mPosition.getZ());
	glEnd();
}

/******************************************************************************/

// a Line is drawn as a segment connecting its current position with where it
// will be after the next step in the simulation

void Line::draw()
{
	glBegin(GL_LINES);
		glColor3f(mColor.getX(), mColor.getY(), mColor.getZ());
		glVertex3f(mPosition.getX(), mPosition.getY(), mPosition.getZ()); // origin of the line
		glVertex3f(mPosition.getX() + mVelocity.getX(), mPosition.getY() + mVelocity.getY(), mPosition.getZ() + mVelocity.getZ()); // ending point of the line
	glEnd();
}
